
/**
 * Produto  uma classe que define a informao e os mtodos  
 * comuns aos vrios produtos de um STOCK de uma empresa.
 * 
 * @author F. Mrio Martins
 * @version 03/04/2005
 */
import java.util.*;
public class Produto {

	// variveis de instncia
	
	private String codigo;   // cdigo
	private String nome;     // descrio
	private int quant;       // quantidade em stock
	private int alarme;      // mnimo de alerta

    /** Construtor base */	
    public Produto() {
        codigo = ""; nome = "";
        quant = 0; alarme = 0;
    }
    
    /** Construtor completo */
    public Produto(String cod, String nom, int qt, int na) {
        codigo = cod; nome = nom; quant = qt; alarme = na;
    }
    
    /** Construtor de cpia */
    public Produto(Produto p) {
        codigo = p.getCodigo(); nome = p.getNome();
        quant = p.getQuant(); alarme = p.getAlarme();
    }

   // Mtodos de Instncia  
   /** Devolve o cdigo do produto */   
   public String getCodigo(){ return codigo;}
   
   /** Devolve o Nome do produto */   
   public String getNome(){ return nome;}
   
   /** Devolve a quantidade actual em stock */  
   public int getQuant(){ return quant;}
   
    /** Devolve o nivel actual de alarme */  
   public int getAlarme(){ return alarme;}
   
   /** Verifica se o produto est em ALARME,
    * ou seja, se tem uma quantidade inferior ao
    * nvel de alarme definido.
    */   
   public boolean estaEmAlarme(){ return quant < alarme;}
   
   // Modificadores	
	/** Incrementa a quantidade em stock */   
    public void somaQuant(int valor){ quant = quant + valor;}
    
    /**
	 * Regista saida de stock de uma dada quantidade deste
	 * produto.
	 */   
    public void saidaStock(int valor){ quant = quant - valor;}
       
    /** Devolve uma String representao do produto. */   
    public String toString() {
        StringBuffer txt = new StringBuffer("\n--- PRODUTO ---");
        txt.append("Codigo: " + codigo + "\n");
        txt.append("Nome: " + nome + "\n");
        txt.append("Quantidade: " + quant + "\n");
        txt.append("Alarme a " + alarme + "unidades." + "\n");
        if(this.estaEmAlarme())
            txt.append("ESTA EM ALARME !!\n");
        return txt.toString();
    }
    
   /** clone() do produto. */
    public Produto clone() { return new Produto(this); }
    
 
}

